print("Timurids Scripts")

include("FLuaVector.lua")

function PositionCalculator(i1, i2)
	return HexToWorld(ToHexFromGrid(Vector2(i1, i2)))
end

local bTimDummy = GameInfoTypes.BUILDING_TIMURID_MOD_DUMMY
local bUniqCaptureDummy = GameInfoTypes.BUILDING_UNIQUE_CAPTURE_DUMMY
local TimuridsID = GameInfoTypes.CIVILIZATION_TIMURIDS_MOD
local L = Locale.ConvertTextKey
local tBuildings = {}

-- Trade Route Yields -- adds dummy buildings to Registan, based on number of International Trade Routes in/out of the Timurid Capital.
function MadrasahTradeYields(PlayerID)
	local pPlayer = Players[PlayerID]

	if not pPlayer:GetCivilizationType() == TimuridsID then return end 

	print("Trade out!")

	local pCapital = pPlayer:GetCapitalCity()
	local tTradeRoutes = pPlayer:GetTradeRoutes()
	local iCounter = 0

	for i, tradeRoute in ipairs(tTradeRoutes) do
		if (tradeRoute.FromCity:IsHasBuilding(GameInfoTypes.BUILDING_TIMURID_MADRASAH_MOD) and tradeRoute.ToCivilizationType ~= TimuridsID) or (tradeRoute.ToCity:IsHasBuilding(GameInfoTypes.BUILDING_TIMURID_MADRASAH_MOD) and tradeRoute.FromCivilizationType ~= TimuridsID) then
			iCounter = iCounter + 1
		end
	end
	
	if pCapital then
		if pCapital:IsHasBuilding(GameInfoTypes.BUILDING_TIMURID_MADRASAH_1_MOD) then
			pCapital:SetNumRealBuilding(GameInfoTypes.BUILDING_TIMURID_MADRASAH_1_DUMMY, iCounter)
		end
		if pCapital:IsHasBuilding(GameInfoTypes.BUILDING_TIMURID_MADRASAH_2_MOD) then
			pCapital:SetNumRealBuilding(GameInfoTypes.BUILDING_TIMURID_MADRASAH_2_DUMMY, iCounter)
		end
		if pCapital:IsHasBuilding(GameInfoTypes.BUILDING_TIMURID_MADRASAH_3_MOD) then
			pCapital:SetNumRealBuilding(GameInfoTypes.BUILDING_TIMURID_MADRASAH_3_DUMMY, iCounter)
		end
	end
end
GameEvents.PlayerDoTurn.Add(MadrasahTradeYields)

-- Jewel of the East UA of Timurids - all conquered buildings are immediately built in capital; consist of 2 functions to achieve UBs; yields on conquer if not conquered before
-- Zero Capture
local zerobuildings = {
	GameInfoTypes.BUILDING_STABLE,
	GameInfoTypes.BUILDING_MONUMENT,
	GameInfoTypes.BUILDING_BARRACKS,
	GameInfoTypes.BUILDING_ARMORY,
	GameInfoTypes.BUILDING_MILITARY_ACADEMY,
	GameInfoTypes.BUILDING_ARSENAL,
	GameInfoTypes.BUILDING_WALLS,
	GameInfoTypes.BUILDING_CASTLE,
	GameInfoTypes.BUILDING_MILITARY_BASE,
	GameInfoTypes.BUILDING_HOTEL,
	GameInfoTypes.BUILDING_CONSTABLE,
	GameInfoTypes.BUILDING_POLICE_STATION,
	GameInfoTypes.BUILDING_EE_BASTION,
	}

-- Standard Capture 66-100
local standardbuildings = {
	GameInfoTypes.BUILDING_AIRPORT,
	GameInfoTypes.BUILDING_AMPHITHEATER,
	GameInfoTypes.BUILDING_AQUEDUCT,
	GameInfoTypes.BUILDING_ARTISTS_GUILD,
	GameInfoTypes.BUILDING_BANK,
	GameInfoTypes.BUILDING_BATH,
	GameInfoTypes.BUILDING_BOMB_SHELTER,
	GameInfoTypes.BUILDING_BROADCAST_TOWER,
	GameInfoTypes.BUILDING_CARAVANSARY,
	GameInfoTypes.BUILDING_CATHEDRAL,
	GameInfoTypes.BUILDING_CHANCERY,
	GameInfoTypes.BUILDING_CHURCH,
	GameInfoTypes.BUILDING_CIRCUS,
	GameInfoTypes.BUILDING_COAL_PLANT,
	GameInfoTypes.BUILDING_COLOSSEUM,
	GameInfoTypes.BUILDING_EE_ACADEMY,
	GameInfoTypes.BUILDING_EE_CLOTH_MILL,
	GameInfoTypes.BUILDING_EE_GALLERY,
	GameInfoTypes.BUILDING_EE_GUNSMITH,
	GameInfoTypes.BUILDING_EE_MANOR,
	GameInfoTypes.BUILDING_EE_MENAGERIE,
	GameInfoTypes.BUILDING_EE_SALON,
	GameInfoTypes.BUILDING_EE_TAVERN,
	GameInfoTypes.BUILDING_EE_WEIGH_HOUSE,
	GameInfoTypes.BUILDING_FACTORY,
	GameInfoTypes.BUILDING_FORGE,
	GameInfoTypes.BUILDING_GARDEN,
	GameInfoTypes.BUILDING_GRANARY,
	GameInfoTypes.BUILDING_GROCER,
	GameInfoTypes.BUILDING_GROVE,
	GameInfoTypes.BUILDING_HERBALIST,
	GameInfoTypes.BUILDING_HOSPITAL,
	GameInfoTypes.BUILDING_HYDRO_PLANT,
	GameInfoTypes.BUILDING_LABORATORY,
	GameInfoTypes.BUILDING_LIBRARY,
	GameInfoTypes.BUILDING_MANDIR,
	GameInfoTypes.BUILDING_MARKET,
	GameInfoTypes.BUILDING_MEDICAL_LAB,
	GameInfoTypes.BUILDING_MINT,
	GameInfoTypes.BUILDING_MONASTERY,
	GameInfoTypes.BUILDING_MOSQUE,
	GameInfoTypes.BUILDING_MUSEUM,
	GameInfoTypes.BUILDING_MUSICIANS_GUILD,
	GameInfoTypes.BUILDING_NUCLEAR_PLANT,
	GameInfoTypes.BUILDING_OBSERVATORY,
	GameInfoTypes.BUILDING_OPERA_HOUSE,
	GameInfoTypes.BUILDING_ORDER,
	GameInfoTypes.BUILDING_PAGODA,
	GameInfoTypes.BUILDING_PUBLIC_SCHOOL,
	GameInfoTypes.BUILDING_RECYCLING_CENTER,
	GameInfoTypes.BUILDING_SHRINE,
	GameInfoTypes.BUILDING_SOLAR_PLANT,
	GameInfoTypes.BUILDING_SPACESHIP_FACTORY,
	GameInfoTypes.BUILDING_STADIUM,
	GameInfoTypes.BUILDING_STOCKYARD,
	GameInfoTypes.BUILDING_STOCK_EXCHANGE,
	GameInfoTypes.BUILDING_STONE_WORKS,
	GameInfoTypes.BUILDING_STUPA,
	GameInfoTypes.BUILDING_TEMPLE,
	GameInfoTypes.BUILDING_THEATRE,
	GameInfoTypes.BUILDING_TRAINSTATION,
	GameInfoTypes.BUILDING_UNIVERSITY,
	GameInfoTypes.BUILDING_WATERMILL,
	GameInfoTypes.BUILDING_WELL,
	GameInfoTypes.BUILDING_WIND_PLANT,
	GameInfoTypes.BUILDING_WINDMILL,
	GameInfoTypes.BUILDING_WORKSHOP,
	GameInfoTypes.BUILDING_WRITERS_GUILD,
	}

-- Coastal
local waterbuildings = {
	GameInfoTypes.BUILDING_LIGHTHOUSE,
	GameInfoTypes.BUILDING_HARBOR,
	GameInfoTypes.BUILDING_SEAPORT,
	GameInfoTypes.BUILDING_EE_DRYDOCK,
	GameInfoTypes.BUILDING_MINEFIELD,
	}

-- Mutually Exclusive
function JewelOfTheEast (iOldOwner, bIsCapital, iX, iY, iNewOwner, iPop, bConquest)
	local pPlayer = Players[iNewOwner];
	
	if not (pPlayer and pPlayer:GetCivilizationType() == TimuridsID) then return end
	
	local pCapital = pPlayer:GetCapitalCity()
	local plot = Map.GetPlot(iX, iY);
	local city = plot:GetPlotCity();
	local title = "Jewel of the East";
	local pCapitalX, pCapitalY, pCapitalID = pCapital:GetX(), pCapital:GetY(), pCapital:GetID()

	if city:GetNumBuilding(bUniqCaptureDummy) == 0 then
		pCapital:SetNumRealBuilding(bTimDummy, (pCapital:GetNumBuilding(bTimDummy) + 1))
		city:SetNumRealBuilding(bUniqCaptureDummy, 1)
		if pPlayer:IsHuman() and pPlayer:IsTurnActive() then
			local vCityPosition = PositionCalculator(pCapitalX, pCapitalY)
			local sName = pCapital:GetName()
			
			pPlayer:AddNotification(NotificationTypes.NOTIFICATION_INSTANT_YIELD,
				'Your Palace in [COLOR_POSITIVE_TEXT]'..sName..'[ENDCOLOR] has gained more yields: +1 [ICON_CULTURE] Culture, +1 [ICON_RESEARCH] Science, +1 [ICON_GOLD] Gold, and  +1 [ICON_PRODUCTION] Production',
				'Artisans captured and brought to '..sName,
				pCapitalX, pCapitalY, pCapitalID)
		end
	end

	for _, iBuilding in pairs(zerobuildings) do
		if (city:GetNumBuilding(iBuilding) > 0) then
			if not pCapital:IsHasBuilding(iBuilding) then
				pCapital:SetNumRealBuilding(iBuilding, 1);
				local descr = "Foreign architects have constructed a " .. Locale.ConvertTextKey(GameInfo.Buildings[iBuilding].Description) .. " in your [ICON_CAPITAL] Capital!";
				pPlayer:AddNotification(NotificationTypes.NOTIFICATION_WONDER_COMPLETED, descr, title, pCapitalX, pCapitalY, iBuilding, -1);
			end
		end
	end
	-- Standard Capture Check
	for _, sBuilding in pairs(standardbuildings) do
		if (city:GetNumBuilding(sBuilding) > 0) then
			if not pCapital:IsHasBuilding(sBuilding) then
				pCapital:SetNumRealBuilding(sBuilding, 1);
				local descr = "Foreign architects have constructed a " .. Locale.ConvertTextKey(GameInfo.Buildings[sBuilding].Description) .. " in your [ICON_CAPITAL] Capital!";
				pPlayer:AddNotification(NotificationTypes.NOTIFICATION_WONDER_COMPLETED, descr, title, pCapitalX, pCapitalY, sBuilding, -1);
			end
		end
	end
	-- Coastal Check
	for _, wBuilding in pairs(waterbuildings) do
		if pCapital:IsCoastal() then
			if (city:GetNumBuilding(wBuilding) > 0) then
				if not pCapital:IsHasBuilding(wBuilding) then
					pCapital:SetNumRealBuilding(wBuilding, 1);
					local descr = "Foreign architects have constructed a " .. Locale.ConvertTextKey(GameInfo.Buildings[wBuilding].Description) .. " in your [ICON_CAPITAL] Capital!";
					pPlayer:AddNotification(NotificationTypes.NOTIFICATION_WONDER_COMPLETED, descr, title, pCapitalX, pCapitalY, wBuilding, -1);
				end
			end
		end
	end
end
GameEvents.CityCaptureComplete.Add(JewelOfTheEast)

-- Permanent yields on city raze -- Adds yields via dummy building to Capital every time Timurids raze a city
function CapitalBonusOnRaze(hexPos, iOldOwner, cityID, iNewOwner)
	local pPlayer = Players[iOldOwner]
		print(pPlayer:GetName())
	local pCapital = pPlayer:GetCapitalCity()
	local pCapitalX, pCapitalY, pCapitalID = pCapital:GetX(), pCapital:GetY(), pCapital:GetID()
	local sName = pCapital:GetName()
	
	if pPlayer:GetCivilizationType() == TimuridsID then
		pCapital:SetNumRealBuilding(bTimDummy, (pCapital:GetNumBuilding(bTimDummy) + 1))
		
		if pPlayer:IsHuman() and pPlayer:IsTurnActive() then
			local vCityPosition = PositionCalculator(pCapitalX, pCapitalY)
			
			pPlayer:AddNotification(NotificationTypes.NOTIFICATION_INSTANT_YIELD,
				'Your Palace in [COLOR_POSITIVE_TEXT]'..sName..'[ENDCOLOR] has gained more yields: +1 [ICON_CULTURE] Culture, +1 [ICON_RESEARCH] Science, +1 [ICON_GOLD] Gold, and  +1 [ICON_PRODUCTION] Production',
				'Artisans fled to '..sName,
				pCapitalX, pCapitalY, pCapitalID)
		end
	end
end
Events.SerialEventCityDestroyed.Add(CapitalBonusOnRaze)